<template>
    <v-container>
        <v-row dense class="pa-0">
            <v-spacer></v-spacer>
            <v-col class="flex-shrink-1 flex-grow-0">
                <v-switch
                    class="mt-0"
                    v-model="localValue.enabled"
                    :loading="loading"
                    :label="$t('enabled')"
                    :true-value="true"
                    :false-value="false"
                    hide-details
                    dense
                ></v-switch>
            </v-col>
        </v-row>

        <validation-observer ref="observer" slim>
            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('name') }}</div>
                    <validation-provider v-slot="{ errors }" name="name" rules="required">
                        <v-text-field
                            v-model="localValue.name"
                            :loading="loading"
                            :error-messages="errors"
                            hide-details="auto"
                            dense
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('code') }}</div>
                    <validation-provider v-slot="{ errors }" name="code" rules="required">
                        <v-text-field
                            v-model="localValue.code"
                            :loading="loading"
                            :error-messages="errors"
                            hide-details="auto"
                            dense
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('plan') }}</div>
                    <validation-provider v-slot="{ errors }" name="plan" rules="required">
                        <v-plan-select
                            v-model="localValue.plan"
                            :errors="errors"
                            :placeholder="$t('plan_select')"
                            outlined
                        >
                        </v-plan-select>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row justify="center">
                <v-col cols="4">
                    <v-btn
                        :loading="loading"
                        @click="validate"
                        color="primary"
                        block
                    >
                        {{ $t('save') }}
                    </v-btn>
                </v-col>
            </v-row>
        </validation-observer>
    </v-container>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from "vee-validate";
    import VPlanSelect from "../VPlanSelect";

    export default {
        name: 'CouponEditForm',
        props: {
            value: {
                type: Object,
                default: () => ({
                    name: null,
                    code: null,
                    plan:null,
                    enabled: false
                })
            },
            loading: {
                type: Boolean,
                default: false
            }
        },
        components: {
            ValidationObserver,
            ValidationProvider,
            VPlanSelect
        },
        computed: {
            localValue: {
                get() {
                    return this.value
                },

                set(val) {
                    this.$emit('input', val)
                }
            }
        },
        methods: {
            async validate() {
                const valid = await this.$refs.observer.validate()

                if(valid) {
                    this.$emit('validated')
                }
            }
        }
    }
</script>

<style scoped>

</style>
